program Brojevi;

uses
  App, Objects, Drivers, Menus, Views, Tezina, Igra, MsgBox;

const
  cmAbout = 1001;
  cmNova = 1002;

type
  TBrojeviApp = object(TApplication)
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

procedure TBrojeviApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~I~gra', 0, NewMenu(
      NewItem('~N~ova', '', kbF2, cmNova, 0,
      NewItem('~O~ igri...', 'F1', kbF1, cmAbout, 0,
      NewLine(
      NewItem('I~z~laz', 'Alt+X', kbAltX, cmQuit, 0,
      nil))))), nil))));
end;

procedure TBrojeviApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R, NewStatusDef(0, $FFFF,
    NewStatusKey('Brojevi u ~Turbo Vision-u~ :)', kbF1, cmAbout,
    StdStatusKeys(nil)), nil)));
end;

procedure TBrojeviApp.HandleEvent(var Event: TEvent);
var
  R: Word;
  B: LongInt;
begin
  inherited HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmAbout:
        MessageBox(#3'Primer programa sa Turbo Vision-om'#13#13 +
          #3'by Srki_82',
          nil, mfInformation or mfOKButton);
      cmNova:
      begin
        case ExecuteDialog(New(PTezinaDlg, Init), nil) of
          cmLako:
          begin
            B := Random(10) + 1;
            R := ExecuteDialog(New(PIgraDlg, Init(cmLako, B)), nil);
          end;
          cmSrednje:
          begin
            B := Random(20) + 1;
            R := ExecuteDialog(New(PIgraDlg, Init(cmSrednje, B)), nil);
          end;
          cmTesko:
          begin
            B := Random(50) + 1;
            R := ExecuteDialog(New(PIgraDlg, Init(cmTesko, B)), nil);
          end;
        end;
        if R = cmPobeda then
          MessageBox('TACNO!!! :)', nil, mfInformation or mfOKButton)
        else
          MessageBox('Pogresno, trazeni broj je %d', @B, mfInformation or mfOKButton);
      end;
    end;
  end;
end;

var
  A: TBrojeviApp;

begin
  Randomize;
  A.Init;
  A.Run;
  A.Done;
end.